/*
 *  Authors:
 *    Per Brand (perbrand@sics.se)
 * 
 *  Contributors:
 *    optional, Contributor's name (Contributor's email address)
 * 
 *  Copyright:
 *    Per Brand, 1998
 * 
 *  Last change:
 *    $Date: 1999/01/21 09:55:05 $ by $Author: schulte $
 *    $Revision: 1.6 $
 * 
 *  This file is part of Mozart, an implementation 
 *  of Oz 3:
 *     http://www.mozart-oz.org
 * 
 *  See the file "LICENSE" or
 *     http://www.mozart-oz.org/LICENSE.html
 *  for information on usage and redistribution 
 *  of this file, and for a DISCLAIMER OF ALL 
 *  WARRANTIES.
 *
 */

#include "base.hh"
#include "dpBase.hh"
#include "msgType.hh"
#include "dpDebug.hh"
#include "msgbuffer.hh"
#include "protocolCredit.hh"
#include "dpMarshaler.hh"

/**********************************************************************/
/*   Credit protocol                                     */
/**********************************************************************/


void sendPrimaryCredit(DSite *sd,int OTI,Credit c){
  PD((CREDIT,"Sending PrimaryCreds c:%d", c));
  MsgBuffer *bs= msgBufferManager->getMsgBuffer(sd);
  Assert(creditSiteOut==NULL);
  marshal_M_OWNER_CREDIT(bs,OTI,c); // no msg credit
  SendTo(sd,bs,M_OWNER_CREDIT,sd,OTI);}

void sendSecondaryCredit(DSite *cs,DSite *sd,int OTI,Credit c){
  PD((CREDIT,"Sending SecondaryCreds c:%d", c));
  MsgBuffer *bs= msgBufferManager->getMsgBuffer(cs);
  marshal_M_OWNER_SEC_CREDIT(bs,sd,OTI,c); // no msg credit
  SendTo(cs,bs,M_OWNER_SEC_CREDIT,sd,OTI);}

void sendCreditBack(DSite* sd,int OTI,Credit c){ 
  if(creditSiteIn==NULL){
    sendPrimaryCredit(sd,OTI,c);
    return;}
  sendSecondaryCredit(creditSiteIn,sd,OTI,c);
  creditSiteIn=NULL;
  return;}


